unit Unit1;
interface

uses
	  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,ComObj,StrUtils, StdCtrls, ComCtrls, ExtCtrls, ShellAPI,IniFiles;

type
	TForm1 = class(TForm)
		SaveDialog1: TSaveDialog;
		Panel1: TPanel;
		Panel2: TPanel;
		Label1: TLabel;
		Label2: TLabel;
		Label3: TLabel;
		Label4: TLabel;
		Label5: TLabel;
		Label6: TLabel;
		ProgressBar1: TProgressBar;
		Button1: TButton;
		ProgressBar2: TProgressBar;
		ProgressBar3: TProgressBar;
		ListView1: TListView;
		Button2: TButton;
		Button3: TButton;
		RadioGroup1: TRadioGroup;
		Label7: TLabel;
		StaticText1: TStaticText;
		Edit1: TEdit;
		Edit2: TEdit;
		Label8: TLabel;
                procedure FormCreate(Sender: TObject);
		procedure Xls2Xls(var row0:integer);
		procedure CallExcel;
		procedure Button1Click(Sender: TObject);
		procedure Button2Click(Sender: TObject);
		procedure Button3Click(Sender: TObject);
		procedure FormResize(Sender: TObject);
		procedure FinishOutput;
		procedure Label7Click(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit1Enter(Sender: TObject);
    procedure Edit2Enter(Sender: TObject);
    procedure Edit2Exit(Sender: TObject);
	private
		DoCancel : Boolean;
		excel: Variant;
		LVHDiff: Integer;
		LVWDiff: Integer;
                skiphead: Integer;
                skipfoot: Integer;
                skiphead_old: Integer;
                skipfoot_old: Integer;
		book: Variant;
		Book1: Variant;
		procedure DropFiles(var Msg:TWMDROPFILES); message WM_DROPFILES;
end;

var
Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Label7Click(Sender: TObject);
var
usage:string;
begin
	usage :='EXCELbooks into 1 Sheet   ver0.22  by '+#13#10+
			#13#10+
			'ygz'+#13#10+
			'EXCELt@C(XLSȂ)уV[gꖇɌ܂B'+#13#10+
			#13#10+
			'ygz'+#13#10+
			't@CN̖{\tgEBhE'+#13#10+
			'hbOhbvāAuJnv{^ĂB'+#13#10+
			'̃t@CƓꏊɌ(xlsin1.***)o͂܂B'+#13#10+
			'io͌`SYLKiftHgj,XLS,CSV)'+#13#10+
			#13#10+
			't@CtH_ɂ܂ꍇ̓Xg̈ԏ܂B'+#13#10+
			'ۑꏊɓt@CΏ㏑邩mF܂B'+#13#10+
			#13#10+
			'eV[g̐擪▖̉s𖳎́As'+#13#10+
			'u擪sƖs𖳎v́ɓĂB(ɖȂ 0 )'+#13#10+
			#13#10+
			'yӁz'+#13#10+
			'EXCEL̃CXg[ĂȂł͓삵܂B';
	showmessage(usage);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
i:Integer;
ListItem: TListItem;
begin
	DragAcceptFiles(Form1.Handle, True);
	DoCancel := False;
	LVHDiff := Panel2.Height - ListView1.Height;
	LVWDiff := Panel2.Width  - ListView1.Width;
	Panel2.Visible := True;
	Panel1.Visible := False;
	RadioGroup1.ItemIndex := 0;
	StaticText1.Visible := True;
	skiphead := StrToInt(Edit1.Text);
	skiphead_old := StrToInt(Edit1.Text);
	skipfoot := StrToInt(Edit2.Text);
	skipfoot_old := StrToInt(Edit2.Text);
	ListView1.Columns.Add;
	ListView1.Columns.Add;
	ListView1.MultiSelect := true;
	ListView1.Columns[0].Caption := 'O';
	ListView1.Columns[0].Width := 70;
	ListView1.Columns[1].Caption := 'ꏊ';
	ListView1.Columns[1].Width := 140;
	for i := 1 to ParamCount do begin
		ListItem := ListView1.Items.Add;
		ListItem.Caption := ExtractFileName(ParamStr(i));
		ListItem.SubItems.Add(ExtractFileDir(ParamStr(i)));
	end;
	if ListView1.Items.Count > 0 then begin
		Button3.Enabled := True;
		StaticText1.Visible := False;
	end;

	try
		excel :=  CreateOleObject('Excel.Application');
	except
		//ExcelCXg[ĂȂꍇ̏I
		on EOleSysError do begin
			showmessage('ExcelCXg[ĂȂƎg܂');
			WindowState := wsMinimized;
			Application.Terminate();
			Exit;
		end;
	end;

	Form1.Show;
end;

procedure TForm1.CallExcel;
var
i: Integer;
row0:integer;
FileName: String;
begin
	Button1.Caption := '~';
	try
		Book1 := excel.WorkBooks.Add;//VKI[v
		row0:=1;
		for i := 0 to ListView1.Items.Count - 1 do begin
			FileName := ListView1.Items[i].SubItems[0] + '\' + ListView1.Items[i].Caption;
			if DoCancel = True then break;
			//XLSt@CȊO͂˂
			//if not AnsiSameText(ExtractFileExt(FileName),'.xls') then begin
			//	Label3.Caption := book.name + 'XLSt@Cł͂܂';
			//	Refresh();
			//	Continue;
			//end;
			//eXLSt@C̃I[vƎ
			excel.EnableEvents := false;//}NU
			book := excel.WorkBooks.Open(FileName);
			excel.EnableEvents := true;//}NēxL
			Label2.Caption := book.Name;
			ProgressBar3.Position := Trunc(100*(i+1)/ListView1.Items.Count);
			Refresh();
			Xls2Xls(row0);
			book.Close;
		end;
		FinishOutput;
	finally
		Book1.Saved := True;
		Book1.Close;
		excel.Quit;
		Application.Terminate();
	end;
end;


procedure TForm1.FinishOutput;
var
outpath: string;
outext:string;
fileformat:integer;
begin
	case RadioGroup1.ItemIndex of
		0: outext := 'slk';
		1: outext := 'csv';
		2: outext := 'xls';
	end;
	outpath := ListView1.Items[0].SubItems[0]+'\xlsin1.'+outext;
	if FileExists(outpath) then begin
		SaveDialog1.Title := outpath + 'ɑ݂܂';
		SaveDialog1.FileName := outpath;
		SaveDialog1.DefaultExt := outext;
		SaveDialog1.Filter := 'SYLK (*.slk)|*.slk|CSV (*.csv)|*.csv|XLS (*.xls)|*.xls';
		SaveDialog1.FilterIndex := RadioGroup1.ItemIndex + 1;
		if SaveDialog1.Execute = False then begin
			showmessage('ʂ͕ۑ܂ł');
			Exit;
		end;
		outpath := SaveDialog1.FileName;
	end;
	outext := ExtractFileExt(outpath);
	if      AnsiSameText(outext,'.slk') then fileformat := 2
	else if AnsiSameText(outext,'.csv') then fileformat := 6
	else if AnsiSameText(outext,'.xls') then fileformat := -4143
	else    Exit;
	Book1.SaveAs(outpath,fileformat);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
		DoCancel := True;
end;

procedure TForm1.Xls2Xls(var row0:integer);
var
sheet: Variant;
page,row,col,maxrow,maxcol,rowini : Integer;
begin
	ProgressBar2.Position := 0;
	//eV[gƂ̏
	for page :=1 to book.Worksheets.Count do begin
		if DoCancel = True then break;
		sheet :=  book.Worksheets[page];	//<-ӁIz񈵂ɂȂ
		Label1.Caption := sheet.Name;
		//V[g̎gp͈͎擾
		maxrow := sheet.UsedRange.Rows[sheet.UsedRange.Rows.Count].Row;
		maxcol := sheet.UsedRange.Columns[sheet.UsedRange.Columns.Count].Column;
		ProgressBar2.Position := Trunc(100*page/book.Worksheets.Count);
		ProgressBar1.Position := 0;
		Refresh();
		//esƂ̏
//		if CheckBox1.Checked = False then
//			rowini := 1 else rowini := 2;
			rowini := 1;
			rowini := rowini + skiphead;
			maxrow := maxrow - skipfoot;
		for row:=rowini to maxrow do begin
			if DoCancel = True then break;
			Book1.Worksheets[1].Cells[row0,1].Value := book.name;
			Book1.Worksheets[1].Cells[row0,2].Value := sheet.name;
			for col :=1 to maxcol do begin
				//[ŨbZ[WMiꂪȂƒ~{^Ȃj
				Application.ProcessMessages;
				if DoCancel = True then break;
				Book1.Worksheets[1].Cells[row0,col+2].NumberFormatLocal := sheet.Cells[row,col].NumberFormatLocal;
				Book1.Worksheets[1].Cells[row0,col+2].Value := sheet.Cells[row,col].Value;
			end;
			Inc(row0);
			ProgressBar1.Position := Trunc(100*row/(maxrow - rowini + 1));
		end;
	end;
end;


procedure TForm1.Button3Click(Sender: TObject);
begin
	Panel2.Visible := False;
	Panel1.Visible := True;
	DragAcceptFiles(Form1.Handle, False);
	CallExcel;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
	ListView1.DeleteSelected;
	if ListView1.Items.Count = 0 then begin
		Button3.Enabled := False;
		StaticText1.Visible := True;
	end;
end;

procedure TForm1.FormResize(Sender: TObject);
var
Width_old,Height_old:integer;
begin
	Height_old := ListView1.Height;
	Width_old := ListView1.Width;
	ListView1.Height := Panel2.Height - LVHDiff;
	ListView1.Width  := Panel2.Width  - LVWDiff;
	StaticText1.Top := StaticText1.Top - (Height_old - ListView1.Height) div 2;
	StaticText1.Left := StaticText1.Left - (Width_old - ListView1.Width) div 2;
end;

procedure TForm1.DropFiles(var Msg:TWMDROPFILES);
var
i, DropFileCount: Integer;
FileName: array [0..255] of Char;
ListItem: TListItem;
begin
	DropFileCount := DragQueryFile(Msg.Drop, Cardinal(-1), nil, 0);
	for i:=0 to DropFileCount-1 do begin
		DragQueryFile(Msg.Drop, i, FileName, SizeOf(FileName)-1);
		ListItem := ListView1.Items.Add;
		ListItem.Caption := ExtractFileName(FileName);
		ListItem.SubItems.Add(ExtractFileDir(FileName));
	end;
	DragFinish(Msg.Drop);
	//rowscolڂ̎QƂ1ڂListView1.Items[row-1].Caption
	//                       ȍ~ListView1.Items[row-1].SubItems[col-2]
	if ListView1.Items.Count > 0 then begin
		Button3.Enabled := True;
		StaticText1.Visible := False;
	end;
end;


procedure TForm1.Edit1Enter(Sender: TObject);
begin
        skiphead_old := skiphead;
end;

procedure TForm1.Edit2Enter(Sender: TObject);
begin
        skipfoot_old := skipfoot;
end;

procedure TForm1.Edit1Exit(Sender: TObject);
begin
	try
		skiphead := StrToInt(Edit1.Text);
	except
		showmessage('ύX̒l͖ł');
		skiphead := skiphead_old;
		Edit1.Text := IntToStr(skiphead);
	end;
end;

procedure TForm1.Edit2Exit(Sender: TObject);
begin
	try
		skipfoot := StrToInt(Edit2.Text);
	except
		showmessage('ύX̒l͖ł');
		skipfoot := skipfoot_old;
		Edit2.Text := IntToStr(skipfoot);
	end;
end;
end.
